import random

from graphs.binary_grammar import Grammar


class CompleteGrammarTree(Grammar):
    """Grammar that creates a complete tree for crosschecking"""
    def __init__(self, goal_prob=[0,0,0.5]):
        rules = [('S', 'Sa'), ('S', 'Sb')]
        goal_strings = []
        for i,p in enumerate(goal_prob):
            for k in range(2**i, 2**(i+1)):
                if random.random() < p:
                    c  = {'0': 'a', '1': 'b'}
                    s  = "S"
                    kb = '{0:b}'.format(k)
                    for i in kb:
                        s = s + c[i]
                    goal_strings.append(s)
        Grammar.__init__(self,
                         start_string = 'S',
                         rules        = rules,
                         goal_strings = goal_strings,
                         max_depth    = len(goal_prob))