import math
import random
import sys
from queue import Queue

import numpy as np
from matplotlib import pyplot as plt

from graphs.n_puzzle import NPuzzleGraph

####################################
#
# TODO: Untried code. Probably does something.
#


max_depth = 33

def desc_counter(G, start_node=None):
    if start_node is None:
        start_node = random.choice(list(G.vertices()))

    if G.depth[start_node] == 0:
        parent = {start_node.__str__(): None}
    else:
        for c in start_node.out_neighbours():
            if G.depth[c] < G.depth[start_node]:
                parent = {start_node.__str__(): c}
                break

    Q = Queue()
    Q.put(start_node)
    visited = set([start_node])
    distance = {}
    distance[start_node.__str__()] = 0
    depths = [[0 for _ in range(max_depth)]
              for _ in range(max_depth)]  # distance -> [d=0, d=1, ...]

    while not Q.empty():
        v = Q.get()
        #print(v.__str__(), G.depth[v])
        depths[distance[v.__str__()]][G.depth[v]] += 1
        children = set(v.out_neighbours())
        for c in children:  # Remove parent
            if parent[v.__str__()] == c:
                children.remove(c)
                break
        # assert len(children) == len(list(v.out_neighbours())) - 1
        for c in children:
            if c.__str__() not in visited:
                visited.add(c.__str__())
                distance[c.__str__()] = distance[v.__str__()] + 1
                parent[c.__str__()] = v
                Q.put(c)
    return (G.depth[start_node], np.matrix(depths))


def iterate(G, iterations=10):
    depthsd = [np.zeros((max_depth, max_depth)) for _ in range(max_depth)]
    nodes_of_depth = G.nodes_of_depth()
    for level in range(max_depth):
        if level not in nodes_of_depth:
            break
        for i in range(iterations):
            if not nodes_of_depth[level]:
                break
            node = random.choice(nodes_of_depth[level])
            nodes_of_depth[level].remove(node)
            print(level, i, file=sys.stderr)
            (d, depths) = desc_counter(G, start_node=node)
            depthsd[d] += depths
    for (i, depths) in enumerate(depthsd):
        print("\n", i)
        for l in depths:
            print(", ".join(map(lambda x: str(int(x)), l)))
    return depths


if __name__ == "__main__":
    G = NPuzzleGraph(n=3)
    iterate(G, 10)
f2 = open('desc_counter_no_parent3.csv')
axlist = []
gmatrix = []
gdiag = []


def read_desc(f):
    global gmatrix
    matrixv = []
    lines = f.readlines()
    for depth in range(32):
        rel = lines[depth*35:(depth+1)*35]
        matrixlist = [np.zeros(32)]  # = np.zeros((32,32))
        for (i, line) in enumerate(rel):
            try:
                line = line.rstrip('\n')
                vec = np.array(list(line.split(", "))).astype(np.int)
                if len(vec) >= 2:
                    matrixlist.append(matrixlist[-1] + vec[:32])
                else:
                    pass
                    print("ignoring short line", i, line)
            except Exception as inst:
                print(inst)
                pass
                # print("ignoring line", i, line)
        matrix = np.array(matrixlist[1:])
        if matrix.ndim != 2:
            print("no matrix..", matrix)
            continue
        #print(matrix)
        samples = matrix[0, depth]
        assert samples != 0
        # print(samples)
        matrix = matrix/samples
        matrixv.append(matrix)
        # print(matrix, sum(sum(matrix)))
        # if sum(sum(matrix)) > 0:
            # plot_desc(matrix, depth)
    # fig.show()
    return matrixv


def print_matrix(matrix):
    if isinstance(matrix, np.ndarray):
        matrix = matrix.tolist()
    for v in matrix:
        print(", ".join(map(str, v)))


matrixv_no_parent = read_desc(f2)


def emp_desc_counter(n, d, matrixv=matrixv_no_parent, D=20):
    depth = n
    distance = D-n
    assert distance >= 0
    d = d
    return matrixv[depth][distance][d]


def plot_desc(n, domain=None, D=20, ax=None):
    if domain is None:
        domain = range(20)
    if ax is None:
        show = True
        ax = plt
    else:
        show = False
    xx = list(domain)
    yemp = [emp_desc_counter(n, d, matrixv=matrixv_no_parent, D=D)
            for d in xx]
    ylow = [desc_counter3(n, d, D=D)[0] for d in xx]
    yhigh = [desc_counter3(n, d, D=D)[1] for d in xx]
    # ylow2 = [desc_counter(n, d, D-n)[0] for d in xx]
    yhigh2 = [desc_counter(n, d, D-n) for d in xx]
    ax.plot(xx, yemp, "--")
    ax.plot(xx, ylow)
    ax.plot(xx, yhigh)
    # ax.plot(xx, ylow2, "..")
    ax.plot(xx, yhigh2, "*")
    if show:
        plt.show()


def three_plots():
    fig = plt.figure()
    i = 0
    for D in [10, 20, 24]:
        for n in [int(0.3*D), int(0.6*D), int(0.9*D)]:
            i += 1
            ax = fig.add_subplot(3, 3, i)
            plot_desc(n, D=D, ax=ax)
            ax.set_title("D = " + str(D) + ", n = " + str(n))
    plt.show()