import numpy as np

from n_puzzle import n_puzzle_params


def goal_levels(G, max_depth=n_puzzle_params.max_depth):
    mh_to_goals = {}
    for v in G.vertices():
        mh = G.vp.mh[v]
        depth = G.vp.depth[v]
        if mh not in mh_to_goals:
            mh_to_goals[mh] = np.zeros(max_depth)
        mh_to_goals[mh][depth] += 1
    return {mh: mh_to_goals[mh]/sum(mh_to_goals[mh]) for mh in mh_to_goals}


# import random
# from queue import Queue
# from graphs.n_puzzle import NPuzzleGraph

# def goal_levels(G, max_depth=32):
#     depth = {}
#     goals = [0 for i in range(max_depth+1)]  # depth -> #goals
#     Q = Queue()
#     Q.put(G.root)
#     depth[G.root] = 0
#     if G.vp.goal[G.root]:
#         goals[0] += 1
#     while not Q.empty():
#         v = Q.get()
#         for new_s in set(v.out_neighbours()):
#             if new_s not in depth:
#                 depth[new_s] = depth[v] + 1
#                 if depth[new_s] < max_depth:
#                     Q.put(new_s)
#                 if G.vp.goal[new_s]:
#                     # print("goal found")
#                     goals[depth[new_s]] += 1
#     return goals
#
#
# def iterate_goal_levels(G, iterations=10, max_depth=32, bg=n_puzzle_params.bgdown, verbose=False):
#     mh_nodes = NPuzzleGraph.nodes_of_mh(G)
#     mh_goal_levels = {}  # mh -> goal_levels
#     mh_goal_prob = {}  # mh -> goal_prob
#     for mh in mh_nodes:
#         mh_goal_levels[mh] = np.zeros(max_depth + 1)
#         for i in range(iterations):
#             G.root = random.choice(mh_nodes[mh])
#             goals = goal_levels(G, max_depth=max_depth)
#             mh_goal_levels[mh] += np.array(goals)/iterations
#             if verbose:
#                 print(mh, i, end=" ")
#         mh_goal_prob[mh] = mh_goal_levels[mh] *\
#                            np.array([bg**(-i) for i in range(max_depth+1)])
#     return mh_goal_levels, mh_goal_prob


