def print_vectors(filename, data):
    names = data.keys()
    vectors = [data[d] for d in names]
    f = open(filename, "w")
    print("\t".join(names), file=f)
    for i in range(len(vectors[0])):
        linev = [v[i] for v in vectors]
        print("\t".join(map(str, linev)), file=f)
    f.close()


def winner(df1, df2, compare_column="emp", type_column="mh"):
    global dfstimes, bfstimes
    bfswins = {}  # type -> win/lose
    dfstimes = {}
    bfstimes = {}
    for (index, row1) in df1.iterrows():
        row2 = df2.iloc[[index]]
        type1 = int(row1[type_column])
        type2 = int(row2[type_column])
        assert type1 == type2
        if type1 not in bfswins:
            bfswins[type1] = []
            dfstimes[type1] = []
            bfstimes[type1] = []
        #print(int(row1[compare_column] - row2[compare_column])
        bfswins[type1].append(int(row1[compare_column]) < int(row2[compare_column]))
        dfstimes[type1].append(int(row2[compare_column]))
        bfstimes[type1].append(int(row1[compare_column]))
    bfswin_perc = {}  # type -> percentage win
    for t in bfswins:
        bfswin_perc[t] = sum(bfswins[t])/len(bfswins[t])
    return bfswins, bfswin_perc


###############################################
#
# Probably unused methods
#
################################################


def goal_distribution_mh4(mh, D=20):
    """
    Estimated goal distribution from Manhattan distance in
    NPuzzleGraph with 8000 nodes.
    """
    sd = 2
    mu = 1.33
    pv = [min(1, math.exp(-(mh*mu - i)**2/(2*sd**2)))
          for i in range(D+1)]
    pv = 71*np.array(pv)/sum(pv)
    pv = np.array([p/bg**i for i, p in enumerate(pv)])
    return pv.clip(0, 1)


def goal_distribution_mh8(mh, D=20):
    """
    Estimated goal distribution from Manhattan distance in
    NPuzzleGraph with 8000 nodes.
    """
    # Problem: The mean is wrong, because dividing with nodes
    sd = 3.5
    mu = 1
    pv = [min(1, math.exp(-(mh*mu - i)**2/(2*sd**2)))
          for i in range(D+1)]
    pv = 2576*np.array(pv)/sum(pv)
    pv = np.array([p/bg**i for i, p in enumerate(pv)])
    return pv.clip(0, 1)