import sys

from tree_and_grammar.tree_and_grammar_experiments import *


def plot(graph, xfeature, _range, yfeatures, init=None, filename=None):
    if filename:
        output = sf.open(filename)
    else:
        output = sys.stdout
    output.write(xfeature + '\t' + '\t'.join([y.__name__ for y in yfeatures]) + '\n')
    init = init or graph.random_init
    kvargs = init()
    for x in _range:
        output.write(str(x))
        kvargs[xfeature] = x
        g = graph(**kvargs)
        for y in yfeatures:
            output.write('\t' + str(y(g)))
        output.write('\n')

def sgl_plot():
    D = 14
    init = lambda: dict( depth=D, goal_prob = 0.01, create_graph = False )
    plot(CompleteTreeSGL, 'goal_depth', range(1,D+1), 
         [CompleteTreeSGL.sgl_expected_bfs, CompleteTreeSGL.sgl_expected_dfs],
         init = init
    )

def plotg(graph, xfeature, yfeatures, inits, filename=None):
    if filename:
        output = sf.open(filename)
    else:
        output = sys.stdout
    output.write(xfeature.__name__ + '\t' + '\t'.join([y.__name__ for y in yfeatures]) + '\n')
    for init in inits:
        g = graph(**init)
        output.write(str(xfeature(g)))
        for y in yfeatures:
            output.write('\t' + str(y(g)))
        output.write('\n')

def sgl_plotg():
    D = 15
    inits = [ dict( depth=D, goal_depth = k, goal_prob = 0.07, create_graph = False )
              for k in range(5,D+1)
            ] 
    plotg(CompleteTreeSGL, 
          CompleteTreeSGL.goal_depth, 
          [CompleteTreeSGL.sgl_expected_bfs, CompleteTreeSGL.sgl_expected_dfs, CompleteTree.has_goal],
          inits,
          filename='sgl.dat'
    )

def bg_plotg():
    D = 14
    inits = [ dict( depth=D, g = k, pg = 0.05, create_graph = False )
              for k in range(5,D+1)
            ]
    CG = ClusteredGrammar
    plotg(CG, 
          CG.goal_depth, 
          [CG.expected_bfs, CG.expected_dfs, CG.expected_dfsl, CG.expected_dfsu],
          inits,
          filename='bg.dat'
    )

# sf = se.SafeFiles('plots')
# sgl_plotg()
# bg_plotg()

# def has_goal(k, p):
#     return 1 - (1 - p)**(2**k)

# def exp_bfs(k):
#     p = 2**(-k + 3)
#     return has_goal(k,p)*(2**k - 1 + expectation_truncated_geometric(p, 2**k)) + \
#         (1 - has_goal(k, p))*2**(15)

# def gamma(p):
#     return np.log2((1-p)/p)/2

def gamma(p, g):
    return np.log2(expectation_truncated_geometric(p, 2**g)-1)/2
